//ss
pipeline {
 agent any
 environment {
     APP_VERSION = "1.5.43"
     MAVEN_PROFILE = "dev"
     CLUSTER_NAME = "nj-gilberto-cluster"
     BRANCH_NAME = "dev-nj-gilberto-cluster"
     DEV_DB_USER = credentials('dev-db-user')
     DEV_DB_PASS = credentials('dev-db-pass')
     DEV_DB_URL = credentials('dev-db-url')
     QA_DB_USER = credentials('qa-db-user')
     QA_DB_PASS = credentials('qa-db-pass')
     QA_DB_URL = credentials('qa-db-url')
     JSA_KEY = credentials('jenkins-sa-file-key')
     GCP_PROJECT_ID = 'acn-gcp-cloudtraining'
 }
   stages {
    stage('Build'){
      steps{
        sh'mvn compile -DskipTests'
        sh'mvn clean package -P${MAVEN_PROFILE} -DskipTests -Dmaven.install.skip=true'
      }
    }
    stage('Docker Build'){
      steps{
        sh'docker build ./ --tag=eu.gcr.io/${GCP_PROJECT_ID}/scrumify-${BRANCH_NAME}:v${APP_VERSION}'
      }
    }
    stage('Publish Image'){
      steps{
        sh'gcloud auth activate-service-account jenkins-sa@acn-gcp-cloudtraining.iam.gserviceaccount.com --key-file=${JSA_KEY}'
        sh'gcloud auth configure-docker'
        sh'docker push eu.gcr.io/${GCP_PROJECT_ID}/scrumify-${BRANCH_NAME}:v${APP_VERSION}'
      }
    }
    stage('Deployment'){
      steps{
        sh'gcloud container clusters get-credentials ${CLUSTER_NAME} --region europe-west1-b   --project ${GCP_PROJECT_ID}'
        sh'kubectl label namespace "dev-nj-gilberto-cluster" istio-injection=enabled istio.io/rev-'
        sh'kubectl apply -f kubernetes/namespace.yaml'
        sh'kubectl apply -f kubernetes/deployment.yaml'
        sh'kubectl apply -f kubernetes/service.yaml'
        sh'kubectl apply -f kubernetes/frontend-ingress.yaml'
        //sh'docker rmi eu.gcr.io/${GCP_PROJECT_ID}/scrumify-${BRANCH_NAME}:v${APP_VERSION}'
        //sh'gcloud container images delete eu.gcr.io/${GCP_PROJECT_ID}/scrumify-${BRANCH_NAME}:v${APP_VERSION}'
      }
    }
}

post {
  success {
   echo 'I succeeded!'
 }
 failure {
   echo 'OOPS, something went wrong :('
 }
}
}
